version: '3'

volumes:
  arnika_crawler_local_postgres_data: {}
  arnika_crawler_local_postgres_data_backups: {}

services:
  django: &django
    build:
      context: .
      dockerfile: ./compose/local/django/Dockerfile
    image: arnika_crawler_local_django
    container_name: arnika_crawler_local_django
    platform: linux/x86_64
    depends_on:
      - postgres
      - redis
    volumes:
      - .:/app:z
    env_file:
      - ./.envs/.local/.django
      - ./.envs/.local/.postgres
    ports:
      - "8000:8000"
    command: /start

  postgres:
    build:
      context: .
      dockerfile: ./compose/production/postgres/Dockerfile
    image: arnika_crawler_production_postgres
    container_name: arnika_crawler_local_postgres
    ports:
      - "5432:5432"
    volumes:
      - arnika_crawler_local_postgres_data:/var/lib/postgresql/data:Z
      - arnika_crawler_local_postgres_data_backups:/backups:z
    env_file:
      - ./.envs/.local/.postgres

  docs:
    image: arnika_crawler_local_docs
    container_name: arnika_crawler_local_docs
    platform: linux/x86_64
    build:
      context: .
      dockerfile: ./compose/local/docs/Dockerfile
    env_file:
      - ./.envs/.local/.django
    volumes:
      - ./docs:/docs:z
      - ./config:/app/config:z
      - ./arnika_crawler:/app/arnika_crawler:z
    ports:
      - "9000:9000"
    command: /start-docs

  redis:
    image: redis:6
    container_name: arnika_crawler_local_redis
    ports:
      - "6379:6379"

  celeryworker:
    <<: *django
    image: arnika_crawler_local_celeryworker
    container_name: arnika_crawler_local_celeryworker
    depends_on:
      - redis
      - postgres
    ports: []
    command: /start-celeryworker

  celerybeat:
    <<: *django
    image: arnika_crawler_local_celerybeat
    container_name: arnika_crawler_local_celerybeat
    depends_on:
      - redis
      - postgres
    ports: []
    command: /start-celerybeat

  flower:
    <<: *django
    image: arnika_crawler_local_flower
    container_name: arnika_crawler_local_flower
    ports:
      - "5555:5555"
    command: /start-flower
